<template>
    <div class="note editor app">
        <div class="note-header">
            <div class="title">
                <textarea
                    @blur="saveNote"
                    v-model="$v.form.title.$model"
                    class="textarea"
                    rows="1"
                    name="title"
                    placeholder="Note Title"
                ></textarea>
                <!-- Error Messages -->
                <span class="error" v-if="!$v.form.title.minLength && $v.form.title.$dirty">
                    <app-icon icon="exclamation-circle"></app-icon>
                    <span class="message">
                        Error: Minimum Length is
                        <strong>2</strong> Characters
                    </span>
                </span>
                <span class="error" v-if="!$v.form.title.maxLength && $v.form.title.$dirty">
                    <app-icon icon="exclamation-circle"></app-icon>
                    <span class="message">
                        Error: Maximium Length is
                        <strong>30</strong> Characters
                    </span>
                </span>
                <span class="error" v-if="!$v.form.title.required && $v.form.title.$dirty">
                    <app-icon icon="exclamation-circle"></app-icon>
                    <span class="message">
                        Error: Note Title Is
                        <strong>Required</strong>
                    </span>
                </span>
            </div>
            <div class="metadata">
                <div class="notebook">
                    <select-note-notebook
                        @selectedNotebook="passSelectedNotebook"
                        :notebook="notebook"
                        :note="note"
                    ></select-note-notebook>
                </div>
                <div class="tags">
                    <select-note-tags :note="note"></select-note-tags>
                </div>
                <div class="date">
                    <span>{{Intl.DateTimeFormat('en-GB').format(new Date())}}</span>
                </div>
                <div class="options">
                    <note-options :note="note"></note-options>
                </div>
            </div>
        </div>
        <div class="note">
            <quill-editor :content="note? note.body: undefined" @input="handleBody"></quill-editor>
        </div>
    </div>
</template>

<script lang='ts'>
import Vue from 'vue'
import Component from 'vue-class-component'
import { Prop, Watch } from 'vue-property-decorator'
import { validationMixin } from 'vuelidate'
import Delta from 'quill-delta'
import { required, minLength, maxLength } from 'vuelidate/lib/validators'
import SelectNoteNotebook from './primitives/SelectNoteNotebook.vue'
import SelectNoteTags from './primitives/SelectNoteTags.vue'
import QuillEditor from './primitives/QuillEditor.vue'
import NoteOptions from '@/app/Editor/components/Note/NoteOptions.vue'
import { INote, INotebook } from '@/store/types/notebooks'

@Component({
    components: {
        SelectNoteNotebook,
        SelectNoteTags,
        QuillEditor,
        NoteOptions,
    },
    mixins: [validationMixin],
    validations: {
        form: {
            title: {
                required,
                minLength: minLength(2),
                maxLength: maxLength(200),
            },
        },
    },
})
export default class Note extends Vue {
    // Lifecycles
    created() {
        if (this.note) {
            this.form = this.note
        }
    }

    updated() {
        if (!this.notebook) {
            this.$router.push('/notebook/')
        }
    }

    // Props

    @Prop() note: INote | null | undefined
    @Prop() notebook: INotebook | null | undefined

    // Data

    form: INote = {
        title: '',
        notebook: this.noteNotebook,
        tags: [],
        createdOn: new Date(),
        editedOn: new Date(),
        body: new Delta().ops,
    }

    // Computed

    get noteNotebook() {
        if (!this.notebook) {
            return {
                id: '1111-7777-0000-1111',
                name: 'Inbox',
            }
        }
        return {
            id: this.notebook.id as string,
            name: this.notebook.name,
        }
    }

    // Watchers

    @Watch('note')
    watchNote(newNote: INote, oldNote: INote) {
        this.form = newNote
    }

    // Methods

    passSelectedNotebook(notebook: INotebook) {
        this.$emit('notebookChange', {
            notebook,
            note: this.note,
        })
    }

    saveNote() {
        if (!this.$v.$invalid) {
            this.form.notebook = this.noteNotebook
            this.$emit('noteChange', this.form)
        }
    }

    handleBody(content: Delta) {
        this.form.body = content.ops
        this.saveNote()
    }
}
</script>